> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Effectiveness

This endpoint returns all the useful information you will ever need on the historical performance of a single validator index. This includes rewards (aggregate and granular), performance (effectiveness and its components), slashing history and much more. For a glossary of the variables returned see [effectiveness](/rated-api/glossary/ethereum/effectiveness).

Here's how to interpret the inputs required to operate it 👇

| Parameter     | Context                                                                                                    |
| :------------ | :--------------------------------------------------------------------------------------------------------- |
| `filterType`  | day and datetime                                                                                           |
| `from`        | Start day (integer) or datetime (e.g. from="2022-12-01")                                                   |
| `granularity` | The size of time increments you are looking to query. Can be `day` / `week` / `month` / `quarter` / `year` |
| `size`        | The number of results included per page                                                                    |
| `include`     | A list of field names. Use it to filter the specific fields you want in the response payload               |


## OpenAPI

````yaml get /v0/eth/validators/{validator_index_or_pubkey}/effectiveness
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v0/eth/validators/{validator_index_or_pubkey}/effectiveness:
    get:
      tags:
        - Validators
      summary: Get Effectiveness
      operationId: >-
        get_effectiveness_v0_eth_validators__validator_index_or_pubkey__effectiveness_get
      parameters:
        - name: validator_index_or_pubkey
          in: path
          required: true
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: string
            title: Validator Index Or Pubkey
        - name: from
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: string
                format: date
              - type: 'null'
            title: From
        - name: size
          in: query
          required: false
          schema:
            type: integer
            default: 10
            title: Size
        - name: granularity
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/DayGranularityEnum'
            default: day
        - name: filterType
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/FilterTypeEnum'
        - name: include
          in: query
          required: false
          schema:
            anyOf:
              - items:
                  type: string
                type: array
              - type: 'null'
            title: Include
        - name: X-Rated-Network
          in: header
          required: false
          schema:
            $ref: '#/components/schemas/Network'
            default: mainnet
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedValidatorEffectiveness'
        '307':
          description: Validator requested by a valid PubKey
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    DayGranularityEnum:
      type: string
      enum:
        - day
        - week
        - month
        - quarter
        - year
        - all
      title: DayGranularityEnum
    FilterTypeEnum:
      type: string
      enum:
        - hour
        - day
        - datetime
      title: FilterTypeEnum
    Network:
      type: string
      enum:
        - mainnet
        - hoodi
        - holesky
      title: Network
    PaginatedValidatorEffectiveness:
      properties:
        page:
          $ref: '#/components/schemas/api__schemas__page__Page'
        total:
          type: integer
          minimum: 0
          title: Total
        data:
          items:
            $ref: '#/components/schemas/ValidatorEffectiveness'
          type: array
          title: Data
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
      type: object
      required:
        - page
        - total
        - data
        - next
      title: PaginatedValidatorEffectiveness
      examples:
        - data:
            - attesterEffectiveness: 98.82005899705014
              avgCorrectness: 0.9925925925925926
              avgInclusionDelay: 1.0044444444444445
              day: 803
              earnings: 2958548
              endEpoch: 180675
              estimatedPenalties: -6461
              estimatedRewards: 2965823
              executionProposedEmptyCount: 0
              proposedCount: 0
              proposerDutiesCount: 0
              slashesCollected: 0
              slashesReceived: 0
              startEpoch: 180899
              sumAllRewards: 2958548
              sumAttestationRewards: 2965823
              sumBaselineMev: 0
              sumConsensusBlockRewards: 0
              sumCorrectHead: 221
              sumCorrectSource: 225
              sumCorrectTarget: 224
              sumExternallySourcedExecutionRewards: 0
              sumInclusionDelay: 226
              sumLateSourcePenalties: 0
              sumLateSourceVotes: 0
              sumLateTargetPenalties: 0
              sumLateTargetVotes: 0
              sumMissedAttestationPenalties: 0
              sumMissedAttestationRewards: 19233
              sumMissedAttestations: 0
              sumMissedConsensusBlockRewards: 0
              sumMissedExecutionRewards: 0
              sumMissedSyncCommitteeRewards: 0
              sumPriorityFees: 0
              sumSyncCommitteePenalties: 0
              sumWrongHeadPenalties: 0
              sumWrongHeadVotes: 3
              sumWrongTargetPenalties: -6461
              sumWrongTargetVotes: 1
              syncSignatureCount: 0
              totalAttestationAssignments: 225
              totalAttestations: 237
              totalUniqueAttestations: 225
              uptime: 1
              validatorEffectiveness: 98.82005899705014
              validatorIndex: 100
          next: >-
            /v0/eth/validators/100/effectiveness?size=1&from=802&granularity=day&filterType=day
          page:
            filterType: day
            granularity: day
            size: 1
          total: 804
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    api__schemas__page__Page:
      properties:
        from:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: From
        to:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: To
        size:
          type: integer
          exclusiveMinimum: 0
          title: Size
          default: 10
        granularity:
          anyOf:
            - $ref: '#/components/schemas/GranularityEnum'
            - type: 'null'
        filterType:
          anyOf:
            - $ref: '#/components/schemas/FilterTypeEnum'
            - type: 'null'
      type: object
      title: Page
    ValidatorEffectiveness:
      properties:
        hour:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Hour
        day:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Day
        startDay:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Startday
        endDay:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Endday
        totalAttestations:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Totalattestations
        totalUniqueAttestations:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Totaluniqueattestations
        sumCorrectHead:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumcorrecthead
        sumCorrectTarget:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumcorrecttarget
        avgCorrectness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avgcorrectness
        totalAttestationAssignments:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Totalattestationassignments
        avgInclusionDelay:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avginclusiondelay
        sumInclusionDelay:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Suminclusiondelay
        uptime:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Uptime
        attesterEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Attestereffectiveness
        proposedCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Proposedcount
        proposerDutiesCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Proposerdutiescount
        proposerEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Proposereffectiveness
        slashesCollected:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Slashescollected
        slashesReceived:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Slashesreceived
        earnings:
          anyOf:
            - type: integer
            - type: 'null'
          title: Earnings
        syncSignatureCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Syncsignaturecount
        validatorEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Validatoreffectiveness
        estimatedRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Estimatedrewards
        estimatedPenalties:
          anyOf:
            - type: integer
            - type: 'null'
          title: Estimatedpenalties
        sumPriorityFees:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumpriorityfees
        sumBaselineMev:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumbaselinemev
        sumMissedExecutionRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Summissedexecutionrewards
        sumConsensusBlockRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumconsensusblockrewards
        sumMissedConsensusBlockRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Summissedconsensusblockrewards
        sumAllRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumallrewards
        sumCorrectSource:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumcorrectsource
        sumMissedSyncSignatures:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Summissedsyncsignatures
        sumSyncCommitteePenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumsynccommitteepenalties
        sumLateSourceVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumlatesourcevotes
        sumWrongTargetVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumwrongtargetvotes
        sumLateTargetVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumlatetargetvotes
        sumWrongTargetPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumwrongtargetpenalties
        sumLateTargetPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumlatetargetpenalties
        sumMissedAttestations:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Summissedattestations
        sumMissedAttestationPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Summissedattestationpenalties
        sumWrongHeadVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumwrongheadvotes
        sumWrongHeadPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumwrongheadpenalties
        sumAttestationRewards:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Sumattestationrewards
        sumLateSourcePenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumlatesourcepenalties
        executionProposedEmptyCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Executionproposedemptycount
        sumMissedAttestationRewards:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Summissedattestationrewards
        sumMissedSyncCommitteeRewards:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Summissedsynccommitteerewards
        sumExternallySourcedExecutionRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumexternallysourcedexecutionrewards
        validatorIndex:
          type: integer
          minimum: 0
          title: Validatorindex
        startEpoch:
          type: integer
          minimum: 0
          title: Startepoch
          readOnly: true
        endEpoch:
          type: integer
          minimum: 0
          title: Endepoch
          readOnly: true
      type: object
      required:
        - totalAttestations
        - totalUniqueAttestations
        - sumCorrectHead
        - sumCorrectTarget
        - avgCorrectness
        - totalAttestationAssignments
        - avgInclusionDelay
        - sumInclusionDelay
        - uptime
        - attesterEffectiveness
        - proposedCount
        - proposerDutiesCount
        - proposerEffectiveness
        - slashesCollected
        - slashesReceived
        - earnings
        - syncSignatureCount
        - validatorEffectiveness
        - estimatedRewards
        - estimatedPenalties
        - sumPriorityFees
        - sumBaselineMev
        - sumMissedExecutionRewards
        - sumConsensusBlockRewards
        - sumMissedConsensusBlockRewards
        - sumAllRewards
        - sumCorrectSource
        - sumMissedSyncSignatures
        - sumSyncCommitteePenalties
        - sumLateSourceVotes
        - sumWrongTargetVotes
        - sumLateTargetVotes
        - sumWrongTargetPenalties
        - sumLateTargetPenalties
        - sumMissedAttestations
        - sumMissedAttestationPenalties
        - sumWrongHeadVotes
        - sumWrongHeadPenalties
        - sumAttestationRewards
        - sumLateSourcePenalties
        - executionProposedEmptyCount
        - sumMissedAttestationRewards
        - sumMissedSyncCommitteeRewards
        - sumExternallySourcedExecutionRewards
        - validatorIndex
        - startEpoch
        - endEpoch
      title: ValidatorEffectiveness
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
    GranularityEnum:
      type: string
      enum:
        - hour
        - day
        - week
        - month
        - quarter
        - year
        - all
      title: GranularityEnum
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````